package geniusweb.ip;

import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertEquals;

import org.junit.Test;

import geniusweb.ip.inputOutput.Input;
import geniusweb.ip.inputOutput.Output;
import geniusweb.ip.ipSolver.IPSolver;
import geniusweb.ip.mainSolver.Result;

public class IpSolverTest {

	@Test
	public void textBookTest() {
		System.out.println("textbook test");
		int numOfAgents = 4;
		double[] coalitionValues = new double[] { 0d, 30d, 40d, 50d, 25d, 60d,
				55d, 90d, 45d, 80d, 70d, 120d, 80d, 100d, 115d, 140d };
		double acceptableRatio = 100;
		Input input = new Input(numOfAgents, coalitionValues, acceptableRatio);
		Result result = new Result(input);
		Output output = new Output(input);

		IPSolver ipSolver = new IPSolver();
		ipSolver.solve(input, output, result);

		System.out.println(result);

		assertArrayEquals(new int[][] { { 3, 4 }, { 1 }, { 2 } },
				result.get_ipBestCSFound());
		assertEquals(150d, result.get_ipValueOfBestCSFound(), 0.00001);
	}

	@Test
	public void anotherTest() {
		// 4 agents; agent2 can be in coalition1 and coalition2;
		// but there is a minimum coalition size of 2.
		System.out.println("another test");
		int numOfAgents = 4;
		double[] coalitionValues = new double[] { 0d, 0d, 0d, 2d, 0d, 0d, 2d,
				0d, 0d, 0d, 0d, 0d, 2d, 0d, 0d, 0d };
		double acceptableRatio = 100;
		Input input = new Input(numOfAgents, coalitionValues, acceptableRatio);
		Result result = new Result(input);
		Output output = new Output(input);

		IPSolver ipSolver = new IPSolver();
		ipSolver.solve(input, output, result);

		System.out.println(result);
		assertArrayEquals(new int[][] { { 3, 4 }, { 1, 2 } },
				result.get_ipBestCSFound());
		assertEquals(4d, result.get_ipValueOfBestCSFound(), 0.00001);

	}

}